// Desktop Demo.cpp

#include "stdafx.h"

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	HDESK hdeskOriginalThread =
		GetThreadDesktop(GetCurrentThreadId());
	HDESK hdeskOriginalInput =
		OpenInputDesktop(0, FALSE, DESKTOP_SWITCHDESKTOP);

	HDESK hdeskNewDesktop = CreateDesktop(
		TEXT("MyDesktop"),
		NULL,
		NULL,
		0,
		GENERIC_ALL,
		NULL);

	SetThreadDesktop(hdeskNewDesktop);

	SwitchDesktop(hdeskNewDesktop);

	MessageBox(
		NULL,
		TEXT("This message is appearing on a new desktop!"),
		TEXT("Desktop Demo"),
		MB_OK);

	SwitchDesktop(hdeskOriginalInput);
	
	SetThreadDesktop(hdeskOriginalThread);
	CloseDesktop(hdeskNewDesktop);

	return 0;
}